<?xml version="1.0" encoding="ascii"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
          "DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
  <title>pyxmpp.sasl.digest_md5</title>
  <link rel="stylesheet" href="epydoc.css" type="text/css" />
  <script type="text/javascript" src="epydoc.js"></script>
</head>

<body bgcolor="white" text="black" link="blue" vlink="#204080"
      alink="#204080">
<!-- ==================== NAVIGATION BAR ==================== -->
<table class="navbar" border="0" width="100%" cellpadding="0"
       bgcolor="#a0c0ff" cellspacing="0">
  <tr valign="middle">
  <!-- Home link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="pyxmpp-module.html">Home</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Tree link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="module-tree.html">Trees</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Index link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="identifier-index.html">Indices</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Help link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="help.html">Help</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Project homepage -->
      <th class="navbar" align="right" width="100%">
        <table border="0" cellpadding="0" cellspacing="0">
          <tr><th class="navbar" align="center"
            ><a class="navbar" target="_top" href="http://pyxmpp.jajcus.net/">PyXMPP</a></th>
          </tr></table></th>
  </tr>
</table>
<table width="100%" cellpadding="0" cellspacing="0">
  <tr valign="top">
    <td width="100%">
      <span class="breadcrumbs">
        <a href="pyxmpp-module.html">Package&nbsp;pyxmpp</a> ::
        <a href="pyxmpp.sasl-module.html">Package&nbsp;sasl</a> ::
        Module&nbsp;digest_md5
      </span>
    </td>
    <td>
      <table cellpadding="0" cellspacing="0">
        <!-- hide/show private -->
        <tr><td align="right"><span class="options">[<a href="javascript:void(0);" class="privatelink"
    onclick="toggle_private();">hide&nbsp;private</a>]</span></td></tr>
      </table>
    </td>
  </tr>
</table>
<!-- ==================== MODULE DESCRIPTION ==================== -->
<h1 class="epydoc">Module digest_md5</h1><p class="nomargin-top"><span class="codelink"><a href="pyxmpp.sasl.digest_md5-pysrc.html">source&nbsp;code</a></span></p>
<p>DIGEST-MD5 authentication mechanism for PyXMPP SASL implementation.</p>
<dl class="rst-docutils">
<dt>Normative reference:</dt>
<dd><ul class="rst-first rst-last rst-simple">
<li><a class="rst-reference external" href="http://www.ietf.org/rfc/rfc2831.txt" target="_top">RFC 2831</a></li>
</ul>
</dd>
</dl>

<!-- ==================== CLASSES ==================== -->
<a name="section-Classes"></a>
<table class="summary" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr bgcolor="#70b0f0" class="table-header">
  <td colspan="2" class="table-header">
    <table border="0" cellpadding="0" cellspacing="0" width="100%">
      <tr valign="top">
        <td align="left"><span class="table-header">Classes</span></td>
        <td align="right" valign="top"
         ><span class="options">[<a href="#section-Classes"
         class="privatelink" onclick="toggle_private();"
         >hide private</a>]</span></td>
      </tr>
    </table>
  </td>
</tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
        <a href="pyxmpp.sasl.digest_md5.DigestMD5ClientAuthenticator-class.html" class="summary-name">DigestMD5ClientAuthenticator</a><br />
      Provides PLAIN SASL authentication for a client.
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
        <a href="pyxmpp.sasl.digest_md5.DigestMD5ServerAuthenticator-class.html" class="summary-name">DigestMD5ServerAuthenticator</a><br />
      Provides DIGEST-MD5 SASL authentication for a server.
    </td>
  </tr>
</table>
<!-- ==================== FUNCTIONS ==================== -->
<a name="section-Functions"></a>
<table class="summary" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr bgcolor="#70b0f0" class="table-header">
  <td colspan="2" class="table-header">
    <table border="0" cellpadding="0" cellspacing="0" width="100%">
      <tr valign="top">
        <td align="left"><span class="table-header">Functions</span></td>
        <td align="right" valign="top"
         ><span class="options">[<a href="#section-Functions"
         class="privatelink" onclick="toggle_private();"
         >hide private</a>]</span></td>
      </tr>
    </table>
  </td>
</tr>
<tr class="private">
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type"><code class="link">str</code></span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.sasl.digest_md5-module.html#_unquote" class="summary-sig-name" onclick="show_private();">_unquote</a>(<span class="summary-sig-arg">s</span>)</span><br />
      Unquote quoted value from DIGEST-MD5 challenge or response.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.sasl.digest_md5-pysrc.html#_unquote">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr class="private">
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type"><code class="link">str</code></span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.sasl.digest_md5-module.html#_quote" class="summary-sig-name" onclick="show_private();">_quote</a>(<span class="summary-sig-arg">s</span>)</span><br />
      Prepare a string for quoting for DIGEST-MD5 challenge or response.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.sasl.digest_md5-pysrc.html#_quote">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr class="private">
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type"><code class="link">str</code></span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.sasl.digest_md5-module.html#_h_value" class="summary-sig-name" onclick="show_private();">_h_value</a>(<span class="summary-sig-arg">s</span>)</span><br />
      H function of the DIGEST-MD5 algorithm (MD5 sum).</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.sasl.digest_md5-pysrc.html#_h_value">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr class="private">
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type"><code class="link">str</code></span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.sasl.digest_md5-module.html#_kd_value" class="summary-sig-name" onclick="show_private();">_kd_value</a>(<span class="summary-sig-arg">k</span>,
        <span class="summary-sig-arg">s</span>)</span><br />
      KD function of the DIGEST-MD5 algorithm.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.sasl.digest_md5-pysrc.html#_kd_value">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr class="private">
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type"><code class="link">str</code></span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.sasl.digest_md5-module.html#_make_urp_hash" class="summary-sig-name" onclick="show_private();">_make_urp_hash</a>(<span class="summary-sig-arg">username</span>,
        <span class="summary-sig-arg">realm</span>,
        <span class="summary-sig-arg">passwd</span>)</span><br />
      Compute MD5 sum of username:realm:password.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.sasl.digest_md5-pysrc.html#_make_urp_hash">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr class="private">
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type"><code class="link">str</code></span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.sasl.digest_md5-module.html#_compute_response" class="summary-sig-name" onclick="show_private();">_compute_response</a>(<span class="summary-sig-arg">urp_hash</span>,
        <span class="summary-sig-arg">nonce</span>,
        <span class="summary-sig-arg">cnonce</span>,
        <span class="summary-sig-arg">nonce_count</span>,
        <span class="summary-sig-arg">authzid</span>,
        <span class="summary-sig-arg">digest_uri</span>)</span><br />
      Compute DIGEST-MD5 response value.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.sasl.digest_md5-pysrc.html#_compute_response">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr class="private">
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type"><code class="link">str</code></span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.sasl.digest_md5-module.html#_compute_response_auth" class="summary-sig-name" onclick="show_private();">_compute_response_auth</a>(<span class="summary-sig-arg">urp_hash</span>,
        <span class="summary-sig-arg">nonce</span>,
        <span class="summary-sig-arg">cnonce</span>,
        <span class="summary-sig-arg">nonce_count</span>,
        <span class="summary-sig-arg">authzid</span>,
        <span class="summary-sig-arg">digest_uri</span>)</span><br />
      Compute DIGEST-MD5 rspauth value.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.sasl.digest_md5-pysrc.html#_compute_response_auth">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
</table>
<!-- ==================== VARIABLES ==================== -->
<a name="section-Variables"></a>
<table class="summary" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr bgcolor="#70b0f0" class="table-header">
  <td colspan="2" class="table-header">
    <table border="0" cellpadding="0" cellspacing="0" width="100%">
      <tr valign="top">
        <td align="left"><span class="table-header">Variables</span></td>
        <td align="right" valign="top"
         ><span class="options">[<a href="#section-Variables"
         class="privatelink" onclick="toggle_private();"
         >hide private</a>]</span></td>
      </tr>
    </table>
  </td>
</tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
        <a name="quote_re"></a><span class="summary-name">quote_re</span> = <code title="re.compile(r'(?&lt;!\\)\\(.)')">re.compile(r'<code class="re-group">(?&lt;!</code>\\<code class="re-group">)</code>\\<code class="re-group">(</code>.<code class="re-group">)</code>')</code>
    </td>
  </tr>
<tr class="private">
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
        <a href="pyxmpp.sasl.digest_md5-module.html#_param_re" class="summary-name" onclick="show_private();">_param_re</a> = <code title="re.compile(r'^(?P&lt;var&gt;[^=]+)=(?P&lt;val&gt;(&quot;(([^&quot;\\]+)|(\\&quot;)|(\\\\))+&quot;)|([^\
&quot;,]+))(\s*,\s*(?P&lt;rest&gt;.*))?$')">re.compile(r'^<code class="re-group">(?P&lt;</code><code class="re-ref">var</code><code class="re-group">&gt;</code><code class="re-group">[^</code>=<code class="re-group">]</code><code class="re-op">+</code><code class="re-group">)</code>=<code class="re-group">(?P&lt;</code><code class="re-ref">val</code><code class="re-group">&gt;</code><code class="re-group">(</code>&quot;<code class="re-group">(</code><code class="re-group">(</code><code class="re-group">[</code><code class="re-op">^</code>&quot;\\<code class="re-group">]</code><code class="re-op">+</code><code class="re-group">)</code><code class="re-op">|</code><code class="variable-ellipsis">...</code></code>
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
        <a name="__package__"></a><span class="summary-name">__package__</span> = <code title="'pyxmpp.sasl'"><code class="variable-quote">'</code><code class="variable-string">pyxmpp.sasl</code><code class="variable-quote">'</code></code>
    </td>
  </tr>
</table>
<p class="indent-wrapped-lines"><b>Imports:</b>
  <span title="binascii.b2a_hex">b2a_hex</span>,
  <span title="re">re</span>,
  <span title="logging">logging</span>,
  <span title="hashlib">hashlib</span>,
  <a href="pyxmpp.sasl.core.ClientAuthenticator-class.html" title="pyxmpp.sasl.core.ClientAuthenticator">ClientAuthenticator</a>,
  <a href="pyxmpp.sasl.core.ServerAuthenticator-class.html" title="pyxmpp.sasl.core.ServerAuthenticator">ServerAuthenticator</a>,
  <a href="pyxmpp.sasl.core.Response-class.html" title="pyxmpp.sasl.core.Response">Response</a>,
  <a href="pyxmpp.sasl.core.Challenge-class.html" title="pyxmpp.sasl.core.Challenge">Challenge</a>,
  <a href="pyxmpp.sasl.core.Success-class.html" title="pyxmpp.sasl.core.Success">Success</a>,
  <a href="pyxmpp.sasl.core.Failure-class.html" title="pyxmpp.sasl.core.Failure">Failure</a>,
  <a href="pyxmpp.utils-module.html#to_utf8" title="pyxmpp.utils.to_utf8">to_utf8</a>,
  <a href="pyxmpp.utils-module.html#from_utf8" title="pyxmpp.utils.from_utf8">from_utf8</a>
</p><br />
<!-- ==================== FUNCTION DETAILS ==================== -->
<a name="section-FunctionDetails"></a>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr bgcolor="#70b0f0" class="table-header">
  <td colspan="2" class="table-header">
    <table border="0" cellpadding="0" cellspacing="0" width="100%">
      <tr valign="top">
        <td align="left"><span class="table-header">Function Details</span></td>
        <td align="right" valign="top"
         ><span class="options">[<a href="#section-FunctionDetails"
         class="privatelink" onclick="toggle_private();"
         >hide private</a>]</span></td>
      </tr>
    </table>
  </td>
</tr>
</table>
<a name="_unquote"></a>
<div class="private">
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">_unquote</span>(<span class="sig-arg">s</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.sasl.digest_md5-pysrc.html#_unquote">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  <p>Unquote quoted value from DIGEST-MD5 challenge or response.</p>
<p>If <code class="link">s</code> doesn't start or doesn't end with '&quot;' then return it unchanged,
remove the quotes and escape backslashes otherwise.</p>
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>s</code></strong> (: <code class="link">str</code>) - : a quoted string.</li>
    </ul></dd>
    <dt>Returns: <code class="link">str</code></dt>
        <dd>the unquoted string.</dd>
  </dl>
</td></tr></table>
</div>
<a name="_quote"></a>
<div class="private">
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">_quote</span>(<span class="sig-arg">s</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.sasl.digest_md5-pysrc.html#_quote">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  <p>Prepare a string for quoting for DIGEST-MD5 challenge or response.</p>
<p>Don't add the quotes, only escape '&quot;' and &quot;&quot; with backslashes.</p>
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>s</code></strong> (: <code class="link">str</code>) - : a raw string.</li>
    </ul></dd>
    <dt>Returns: <code class="link">str</code></dt>
        <dd><code class="link">s</code> with '&quot;' and &quot;&quot; escaped using &quot;&quot;.</dd>
  </dl>
</td></tr></table>
</div>
<a name="_h_value"></a>
<div class="private">
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">_h_value</span>(<span class="sig-arg">s</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.sasl.digest_md5-pysrc.html#_h_value">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  H function of the DIGEST-MD5 algorithm (MD5 sum).
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>s</code></strong> (: <code class="link">str</code>) - : a string.</li>
    </ul></dd>
    <dt>Returns: <code class="link">str</code></dt>
        <dd>MD5 sum of the string.</dd>
  </dl>
</td></tr></table>
</div>
<a name="_kd_value"></a>
<div class="private">
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">_kd_value</span>(<span class="sig-arg">k</span>,
        <span class="sig-arg">s</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.sasl.digest_md5-pysrc.html#_kd_value">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  KD function of the DIGEST-MD5 algorithm.
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>k</code></strong> (: <code class="link">str</code>) - : a string.</li>
        <li><strong class="pname"><code>s</code></strong> (: <code class="link">str</code>) - : a string.</li>
    </ul></dd>
    <dt>Returns: <code class="link">str</code></dt>
        <dd>MD5 sum of the strings joined with ':'.</dd>
  </dl>
</td></tr></table>
</div>
<a name="_make_urp_hash"></a>
<div class="private">
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">_make_urp_hash</span>(<span class="sig-arg">username</span>,
        <span class="sig-arg">realm</span>,
        <span class="sig-arg">passwd</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.sasl.digest_md5-pysrc.html#_make_urp_hash">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  Compute MD5 sum of username:realm:password.
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>username</code></strong> (: <code class="link">str</code>) - : a username.</li>
        <li><strong class="pname"><code>realm</code></strong> (: <code class="link">str</code>) - : a realm.</li>
        <li><strong class="pname"><code>passwd</code></strong> (: <code class="link">str</code>) - : a password.</li>
    </ul></dd>
    <dt>Returns: <code class="link">str</code></dt>
        <dd>the MD5 sum of the parameters joined with ':'.</dd>
  </dl>
</td></tr></table>
</div>
<a name="_compute_response"></a>
<div class="private">
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">_compute_response</span>(<span class="sig-arg">urp_hash</span>,
        <span class="sig-arg">nonce</span>,
        <span class="sig-arg">cnonce</span>,
        <span class="sig-arg">nonce_count</span>,
        <span class="sig-arg">authzid</span>,
        <span class="sig-arg">digest_uri</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.sasl.digest_md5-pysrc.html#_compute_response">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  Compute DIGEST-MD5 response value.
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>urp_hash</code></strong> (: <code class="link">str</code>) - : MD5 sum of username:realm:password.</li>
        <li><strong class="pname"><code>nonce</code></strong> (: <code class="link">str</code>) - : nonce value from a server challenge.</li>
        <li><strong class="pname"><code>cnonce</code></strong> - : cnonce value from the client response.</li>
        <li><strong class="pname"><code>nonce_count</code></strong> (: <code class="link">int</code>) - : nonce count value.</li>
        <li><strong class="pname"><code>authzid</code></strong> (: <code class="link">str</code>) - : authorization id.</li>
        <li><strong class="pname"><code>digest_uri</code></strong> (: <code class="link">str</code>) - : digest-uri value.</li>
    </ul></dd>
    <dt>Returns: <code class="link">str</code></dt>
        <dd>the computed response value.</dd>
  </dl>
</td></tr></table>
</div>
<a name="_compute_response_auth"></a>
<div class="private">
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">_compute_response_auth</span>(<span class="sig-arg">urp_hash</span>,
        <span class="sig-arg">nonce</span>,
        <span class="sig-arg">cnonce</span>,
        <span class="sig-arg">nonce_count</span>,
        <span class="sig-arg">authzid</span>,
        <span class="sig-arg">digest_uri</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.sasl.digest_md5-pysrc.html#_compute_response_auth">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  Compute DIGEST-MD5 rspauth value.
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>urp_hash</code></strong> (: <code class="link">str</code>) - : MD5 sum of username:realm:password.</li>
        <li><strong class="pname"><code>nonce</code></strong> (: <code class="link">str</code>) - : nonce value from a server challenge.</li>
        <li><strong class="pname"><code>cnonce</code></strong> - : cnonce value from the client response.</li>
        <li><strong class="pname"><code>nonce_count</code></strong> (: <code class="link">int</code>) - : nonce count value.</li>
        <li><strong class="pname"><code>authzid</code></strong> (: <code class="link">str</code>) - : authorization id.</li>
        <li><strong class="pname"><code>digest_uri</code></strong> (: <code class="link">str</code>) - : digest-uri value.</li>
    </ul></dd>
    <dt>Returns: <code class="link">str</code></dt>
        <dd>the computed rspauth value.</dd>
  </dl>
</td></tr></table>
</div>
<br />
<!-- ==================== VARIABLES DETAILS ==================== -->
<a name="section-VariablesDetails"></a>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr bgcolor="#70b0f0" class="table-header">
  <td colspan="2" class="table-header">
    <table border="0" cellpadding="0" cellspacing="0" width="100%">
      <tr valign="top">
        <td align="left"><span class="table-header">Variables Details</span></td>
        <td align="right" valign="top"
         ><span class="options">[<a href="#section-VariablesDetails"
         class="privatelink" onclick="toggle_private();"
         >hide private</a>]</span></td>
      </tr>
    </table>
  </td>
</tr>
</table>
<a name="_param_re"></a>
<div class="private">
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <h3 class="epydoc">_param_re</h3>
  
  <dl class="fields">
  </dl>
  <dl class="fields">
    <dt>Value:</dt>
      <dd><table><tr><td><pre class="variable">
re.compile(r'^<code class="re-group">(?P&lt;</code><code class="re-ref">var</code><code class="re-group">&gt;</code><code class="re-group">[^</code>=<code class="re-group">]</code><code class="re-op">+</code><code class="re-group">)</code>=<code class="re-group">(?P&lt;</code><code class="re-ref">val</code><code class="re-group">&gt;</code><code class="re-group">(</code>&quot;<code class="re-group">(</code><code class="re-group">(</code><code class="re-group">[</code><code class="re-op">^</code>&quot;\\<code class="re-group">]</code><code class="re-op">+</code><code class="re-group">)</code><code class="re-op">|</code><code class="re-group">(</code>\\&quot;<code class="re-group">)</code><code class="re-op">|</code><code class="re-group">(</code>\\\\<code class="re-group">)</code><code class="re-group">)</code><code class="re-op">+</code>&quot;<code class="re-group">)</code><code class="re-op">|</code><code class="re-group">(</code><code class="re-group">[</code><code class="re-op">^</code><span class="variable-linewrap"><img src="crarr.png" alt="\" /></span>
&quot;,<code class="re-group">]</code><code class="re-op">+</code><code class="re-group">)</code><code class="re-group">)</code><code class="re-group">(</code>\s<code class="re-op">*</code>,\s<code class="re-op">*</code><code class="re-group">(?P&lt;</code><code class="re-ref">rest</code><code class="re-group">&gt;</code>.<code class="re-op">*</code><code class="re-group">)</code><code class="re-group">)</code><code class="re-op">?</code>$')
</pre></td></tr></table>
</dd>
  </dl>
</td></tr></table>
</div>
<br />
<!-- ==================== NAVIGATION BAR ==================== -->
<table class="navbar" border="0" width="100%" cellpadding="0"
       bgcolor="#a0c0ff" cellspacing="0">
  <tr valign="middle">
  <!-- Home link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="pyxmpp-module.html">Home</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Tree link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="module-tree.html">Trees</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Index link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="identifier-index.html">Indices</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Help link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="help.html">Help</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Project homepage -->
      <th class="navbar" align="right" width="100%">
        <table border="0" cellpadding="0" cellspacing="0">
          <tr><th class="navbar" align="center"
            ><a class="navbar" target="_top" href="http://pyxmpp.jajcus.net/">PyXMPP</a></th>
          </tr></table></th>
  </tr>
</table>
<table border="0" cellpadding="0" cellspacing="0" width="100%%">
  <tr>
    <td align="left" class="footer">
    Generated by Epydoc 3.0.1 on Sun May  8 13:34:58 2011
    </td>
    <td align="right" class="footer">
      <a target="mainFrame" href="http://epydoc.sourceforge.net"
        >http://epydoc.sourceforge.net</a>
    </td>
  </tr>
</table>

<script type="text/javascript">
  <!--
  // Private objects are initially displayed (because if
  // javascript is turned off then we want them to be
  // visible); but by default, we want to hide them.  So hide
  // them unless we have a cookie that says to show them.
  checkCookie();
  // -->
</script>
</body>
</html>
